#include <omniORB4/CORBA.h>
#include "AddrBook.hh"
#include <fstream>
#include <cstdlib> // fuer exit()
#include <iostream> // fuer cout
using namespace std;

#define APPEND 1
#define FIND   2

int main(int argc, char * argv[]) {
	int rc = 0;
	CORBA::ORB_var orb = CORBA::ORB_init(argc , argv);
	int mode;
	if (( argc < 3) || ( argc > 4)) {
		cout<<"usage: "<<argv[0]<<" -a name no | -f name"<<endl;
		exit(1);
	}
	if (strcmp(argv[1], "-a") == 0) mode = APPEND;
	else if (strcmp(argv[1], "-f") == 0) mode = FIND;
	else {
		cout<<"usage: "<<argv[0]<<" -a name no | -f name"<<endl;
		exit(1);
	}
	char s[1000];
	ifstream in("AddrBook.ref");
	in >> s;
	in.close();

	try {
		CORBA::Object_var obj = orb->string_to_object(s);
		AddrBook_var f = AddrBook::_narrow(obj);
		if(mode == APPEND)
			f->addAddr(argv[2], argv[3]);
		else {
			string no = f->getAddr(argv[2]);
			cout<<"number of "<<argv[2]<< ": "<<no<<endl;
		}
	} catch(AddrNotFoundException & ex) {
		cout<<"number of "<<ex.msg<<" not found"<<endl;
		rc = 0;
	} catch(CORBA::SystemException & ex) {
		cerr<<ex._name()<<endl;
		rc = 1;
	}
	return rc;
}
